%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%-------------------EOST, J. Maury---------------------- 
%--------------------------------------------------------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% This script prepare the parameters to include in the input file of Meca2tens
% It asks for: an earthquake file (if a distance criterion is adde) and a 
% focal mechanism file
% FM file:
%   year month day hour min sec lat lon depth Ml Mw str dip rake
%   only mw is used so the value of ml does not matter
% EQ file:
%   year month day hour min sec lat lon dep ml mw MF
%   only mw is used so the value of ml does not matter
%   MF is a parameter to check whether a FM exists for the corrrespond EQ
%   MF=F (yes) MF=N (no)
clear all
close all
%
disp(' ')
disp('*******************************************************')
%
parametres.inv = input(' Inversion n°?');
%
if parametres.inv==1
  parametres.nomout = input(' Output files prefix? ', 's');
  parametres.nomin = input(' Focal mechanism file? ', 's');
  parametres.mag_coup = input(' Minimum magnitude accepted? (put 0 if you want no magnitude limit)');
  parametres.dist_crit = input(' Distance criterion? (1 if yes 0 if no)');
  if parametres.dist_crit==1
    parametres.nomea = input(' Earthquakes file? ', 's');
    parametres.RFAC = input(' RFAC parameter? (suggested values 1 or 2)');
  end
%
  parametres.sigmi = input('Uncertainty due to the heterogeneity of the media?(0 if not considered)');
  parametres.jklm = input('Ponderation for the fault sorting? (1 no/ 2 rough one)');
%
  parametres.ang = input('Angular increment for the Euler angles?');
  parametres.dr = input('R increment?');
%open FM file
  fid=fopen(parametres.nomin,'r');
  c=textscan(fid,'%d %d %d %d %d %f %f %f %f %f %f %f %f %f %f %f');
  fclose(fid);
  parametres.lat=c{7};
  parametres.lon=c{8};
  parametres.depth=c{9};
  parametres.mw=c{11};
  parametres.st=c{12};
  parametres.dp=c{13};
  parametres.rk=c{14};
  parametres.erp1=c{15};
  parametres.erp2=c{16};
%select events
  if parametres.dist_crit==1
    parametres = exclusion(parametres);
  else
    parametres.id = 1:length(parametres.lat);
  end
else
  parametres.nomout = input(' Files prefix of the first inversion with Meca2tensb? ', 's');
  parametres.p22out = input('Output file of P22?', 's');
end
%write output file
parametres = Inv_entree(parametres);

