%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%    Write the input file for P22 and P22_ERR
% P22: determination of the best solution in the least squares sense
% P22_ERR: determination of the uncertainty domain (200 random selections of fm)
%File format
% NBmf NBp
% str dp rk
% sps sph ste sr
% sstr sdip srke
% psi phi teta r
%
% NBmf: number of focal mechanisms (FM)
% NBp: number of param+unknowns (3*NBmf+4)
% str, dp, rk: strike, dip rake of the plane selected as fault plane in the first step for each FM
% sps, sph, ste, sr: a priori variance for psi, phi teta and r 
% sstr, sdip, srke: a priori variance for the data
% psi, phi, teta, r: initial solution from the approximative method
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
close all
%
nom = input(' files prefix? ', 's');
it = input(' sol n°? (1=best tensor; 2=1st min for reduced misfit...) ', 's');
it=str2num(it);
itn = input(' iteration number? (1=1st use of the iterative process... ', 's');
fol = input(' Folder name for P22_ERR ', 's');
%
fid = fopen(nom,'r');
c=textscan(fid,'%d %d',1);
NMF=c{1};
fclose(fid);
%%% READING OF THE OUTPUT OF Meca2tensb
% a priori variances for the parameters, check eul_verif to determine them
stpsi = input(' a priori variances for psi? (check eul_verif to determine it)', 's');
stphi = input(' a priori variances for phi? ', 's');
sttet = input(' a priori variances for teta? ', 's');
str = input(' a priori variances for r? ', 's');
stpsi=str2num(stpsi);
stphi=str2num(stphi);
sttet=str2num(sttet);
str=str2num(str);
%
fmec=['mfoy_' nom];
fid=fopen(fmec,'r');
if it==1
c=textscan(fid,'%d %f %f %f %f %f %f %f %f %f %f %f %f %f %f %d',...
NMF,'headerlines',1);
else
hnb=it+NMF;
c=textscan(fid,'%d %f %f %f %f %f %f %f %f %f %f %f %f %f %f %d',...
NMF,'headerlines',hnb);
end
verd=c{1};
sti1=c{2};
dpi1=c{3};
rki1=c{4};
rko1=c{7};
sti2=c{8};
dpi2=c{9};
rki2=c{10};
rko2=c{13};
ap=c{14};
aa=c{15};
co=c{16};
fclose(fid);
%%%angles d'euler et r sortie de Meca2tensb (meilleur tenseur), tenseur
%%%initial pour P22
fid=fopen(['mtens_' nom],'r');
c=textscan(fid,'%f %f %f %f %f %f %f %f %f %f');
fclose(fid);
ps=c{8};
ph=c{9};
te=c{10};
r=c{7};
ps0=ps(it);
ph0=ph(it);
te0=te(it);
r0=r(it);
%%% INPUT FILENAME FOR P22
if itn>1
  fico=fopen([nom(1:length(nom)-2) '.in' num2str(itn)],'wt');
else
  fico = fopen([nom '.in' num2str(itn)],'wt');
end
%%% UNCERTAINTY ON THE NODAL PLANES
fid = fopen(nom,'r');
c=textscan(fid,'%f %f',NMF,'headerlines',NMF+1);
std1=c{1};
std2=c{2};
fclose(fid);
%%%% withdraw FM with slip in the wrong direction
idex = rki1.*rko1>0 | rki2.*rko2>0;
sti11=sti1(idex);
dpi11=dpi1(idex);
rki11=rki1(idex);
sti22=sti2(idex);
dpi22=dpi2(idex);
rki22=rki2(idex);
nr=co(idex);
app=ap(idex);
aaa=aa(idex);
vert=verd(idex);
Nf=length(sti11);
sdar1=std1(idex);
sdar2=std2(idex);
%%%% withdraw FM with a rotation angle greater than the uncertainty on the FM
crit=zeros(Nf,1);
ntri = nr==1;
crit(ntri) = sdar1(ntri);
crit(~ntri) = sdar2(~ntri);
cpt=zeros(Nf,1);
for i=1:Nf
    if app(i)<crit(i)
        cpt(i)=1;
    else
        cpt(i)=0;
    end
end
idg = cpt==1;
si1=sti11(idg);
Li=length(si1);
di1=dpi11(idg);
ri1=rki11(idg);
si2=sti22(idg);
di2=dpi22(idg);
ri2=rki22(idg);
nf=nr(idg);
stdf1=sdar1(idg);
stdf2=sdar2(idg);
verh=vert(idg);
%%%
M=Li;
N=3*M+4;
fprintf(fico,'%d %d\n',M,N);
sa1=zeros(Li,1);
da1=sa1;
ra1=sa1;
for i=1:Li
        if nf(i)==1
            sa1(i)=si1(i);
            da1(i)=di1(i);
            ra1(i)=ri1(i);
        else
            sa1(i)=si2(i);
            da1(i)=di2(i);
            ra1(i)=ri2(i);
        end
        fprintf(fico,'%5.1f %5.1f %5.1f \n',sa1(i),da1(i),ra1(i));  
end
%
fprintf(fico,'%5.1f %5.1f %5.1f %4.2f\n',stpsi,stphi,sttet,str);
%
sds=zeros(Li,1);
sdd=sds;
sdr=sds;
for i=1:Li
    if nf(i)==1
        sds(i)=stdf1(i)*stdf1(i);
        sdd(i)=stdf1(i)*stdf1(i);
        sdr(i)=stdf2(i)*stdf2(i);
    else
        sds(i)=stdf2(i)*stdf2(i);
        sdd(i)=stdf2(i)*stdf2(i);
        sdr(i)=stdf1(i)*stdf1(i);
    end
    if (sds(i)<0.5)
      sds(i)=1;
      fprintf('Nul variance for strike of FM %s. Variance put to 1\n',num2str(i));
    end
    if (sdr(i)<0.5)
      sdr(i)=1;
      fprintf('Nul variance for rake of FM %s. Variance put to 1\n',num2str(i));
    end
    if (sdd(i)<0.5)
      sdd(i)=1;
      fprintf('Nul variance for dip of FM %s. Variance put to 1\n',num2str(i));
    end
    fprintf(fico,'%d %d %d\n',sds(i),sdd(i),sdr(i));
end
fprintf(fico,'%3.1f %3.1f %3.1f %3.1f\n',ps0,ph0,te0,r0);
fclose(fico);
%%%%%%%%%%%%%%%%%
% PREPARATION OF THE FILES FOR P22_ERR
% a folder P2ERR must exist
%%%%%%%%%%%%%%%%%
azno=zeros(M,999);
dpno=azno;
rkno=azno;
for j=1:M
    aa=normrnd(sa1(j),sqrt(sds(j)),[1 999]);
    azno(j,:)=aa;%mod(aa,360);
    bb=normrnd(da1(j),sqrt(sdd(j)),[1 999]);
    dpno(j,:)=bb;%mod(bb,360);
    cc=normrnd(ra1(j),sqrt(sdr(j)),[1 999]);
    rkno(j,:)=cc;%mod(cc,360);
end
for j=1:999
    if j<10
        name=[fol '/err00' num2str(j)];
    elseif j<100
        name=[fol '/err0' num2str(j)];
    else
        name=[fol '/err' num2str(j)];
    end
    name=char(name);
    fic=fopen(name,'wt');
    fprintf(fic,'%d %d\n',M,N);
    for i=1:M
        fprintf(fic,'%4.1f %4.1f %4.1f\n',azno(i,j),dpno(i,j),rkno(i,j));
    end
    fprintf(fic,'%3.1f %3.1f %3.1f %3.2f\n',stpsi,stphi,sttet,str);
    for i=1:M
        fprintf(fic,'%d %d %d\n',sds(i),sdd(i),sdr(i));
    end
    fprintf(fic,'%3.1f %3.1f %3.1f %3.1f\n',ps0,ph0,te0,r0);
    fclose(fic);
end
