%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%   Plot the results of P22 and P22_ERR
% Plot the best tensor and the points within the 90% confidence domain
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
close all
%
nom = input(' Best solution file? ', 's');
fid = fopen(nom,'r');
c=textscan(fid,'%f %f %f %f',1);
psif=c{1};
phif=c{2};
tetf=c{3};
rf=c{4};
fclose(fid);
%
fold = input(' Folder for uncertainty domain? ', 's');
fid = fopen([fold '/outten'],'r');
c=textscan(fid,'%f %f %f %f');
psi=c{1};
phi=c{2};
tet=c{3};
r=c{4};
fclose(fid);
%
psi=[psi ; psif];
phi=[phi ; phif];
te=[tet ; tetf];
%r=[r ; rf];
%
L=length(psi);
az1=zeros(L,1);
dp1=az1;
az2=az1;
dp2=az1;
az3=az1;
dp3=az1;
az3i=az3;
az1i=az1;
az2i=az2;
for i=1:L
    if (phi(i)<0)
        phi(i)=phi(i)+180;
    end
%
% Sigma 1 estimation
%
    if (psi(i)>180)
        psi(i)=psi(i)-180;
    end
    if (phi(i)>180)
        phi(i)=phi(i)-180;
    end
    if (te(i)>180)
        te(i)=te(i)-180;
    end
if (phi(i)<=90)
    sig1d = psi(i) + 180;
    sig1p = 90 - phi(i);
else
    sig1d = psi(i);
    sig1p = phi(i) - 90;
end
if (sig1d>=360)
    sig1d = sig1d - 360;
end
if (sig1p>=360)
    sig1p = sig1p - 360;
end
%     
% Sigma 2 estimation
%
if (phi(i)<=90)
    if (phi(i)==90)
        sig2d = psi(i) + 90 - te(i);
    else
        if (te(i)<=90)
            if (te(i)==90)
                sig2d = psi(i);
            else
                sig2d = psi(i) + 90 - atan(sin(phi(i)*pi/180)...
                    *tan(te(i)*pi/180))*180/pi;
            end
        else
                sig2d = psi(i) + 90 - atan(sin(phi(i)*pi/180)...
                    *tan(te(i)*pi/180))*180/pi + 180;
        end
    end
else
    if (te(i)<=90)
        if (te(i)==90)
                sig2d = psi(i) + 180;
        else
                sig2d = psi(i) + 90 - atan(sin(phi(i)*pi/180)...
                    *tan(te(i)*pi/180))*180/pi + 180;
        end
    else
        sig2d = psi(i) + 90 - atan(sin(phi(i)*pi/180)...
                *tan(te(i)*pi/180))*180/pi;
    end
end
sig2p = 90 - abs(asin(cos(phi(i)*pi/180)...
     *sin(te(i)*pi/180))*180/pi);
if (sig2d>=360)
    sig2d = sig2d - 360;
end
if (sig2p>=360)
    sig2p = sig2p - 360;
end
%     
% Sigma 3 estimation
%
if (phi(i)<=90)
    if (phi(i)==90)
        sig3d = psi(i) - te(i);
    else
        if (te(i)==90)
            sig3d = psi(i) - 90;
        end
        if ((te(i)==0)||(te(i)==180))
            sig3d = psi(i);
        end
        if ((te(i)<90)&&(te(i)~=0))
            sig3d = psi(i) - 90 + atan(sin(phi(i)*pi/180)...
             /tan(te(i)*pi/180))*180/pi;
        else
            if ((te(i)>90)&&(te(i)~=180))
                sig3d = psi(i) - 90 + atan(sin(phi(i)*pi/180)...
                /tan(te(i)*pi/180))*180/pi + 180;
            end
        end
    end
else
  if (te(i)==90)
     sig3d = psi(i) - 90;
  end
  if ((te(i)==0)||(te(i)==180))
     sig3d = psi(i) + 180;
  end
  if ((te(i)<90)&&(te(i)~=0))
     sig3d = psi(i) - 90 + atan(sin(phi(i)*pi/180)...
         /tan(te(i)*pi/180))*180/pi + 180;
  else
     if ((te(i)>90)&&(te(i)~=180))
        sig3d = psi(i) - 90 + atan(sin(phi(i)*pi/180)...
            /tan(te(i)*pi/180))*180/pi;
     end
  end
end
%
sig3p = 90 - abs(asin(cos(phi(i)*pi/180)...
    *cos(te(i)*pi/180))*180/pi);
if (sig3d>=360)
  sig3d = sig3d - 360;
end
if (sig3p>=360)
  sig3p = sig3p - 360;
end
if (sig1d<0)
    sig1d=360+sig1d;
end
if (sig2d<0)
    sig2d=360+sig2d;
end
if (sig3d<0)
    sig3d=360+sig3d;
end
sig1p=sig1p*pi/180;
sig1d=sig1d*pi/180;
sig2p=sig2p*pi/180;
sig2d=sig2d*pi/180;
sig3p=sig3p*pi/180;
sig3d=sig3d*pi/180;
az1(i)=sig1d;
dp1(i)=sig1p;
az2(i)=sig2d;
dp2(i)=sig2p;
az3(i)=sig3d;
dp3(i)=sig3p;
if sig3d>pi
    az3i(i)=sig3d-pi;
else
    az3i(i)=sig3d;
end
if sig1d<pi
    az1i(i)=sig1d+pi;
else
    az1i(i)=sig1d;
end
    az2i(i)=sig2d;
end
%angle between s1 and s'1 and s3 and s'3
vec3=zeros(L,3);
vec3(:,1)=cos(az3i).*cos(pi/2-dp3);
vec3(:,2)=sin(az3i).*cos(pi/2-dp3);
vec3(:,3)=sin(pi/2-dp3);
nvec3=sqrt(vec3(:,1).^2+vec3(:,2).^2+vec3(:,3).^2);
for i=1:3
    vec3(:,i)=vec3(:,i)./nvec3;
end
tr3=zeros(L-1,1);
disf=0;
for j=1:(L-1)
    disi=(vec3(end,1)*vec3(j,1)+vec3(end,2)*vec3(j,2)+vec3(end,3)*vec3(j,3));
    dist=acos(disi);
    tr3(j)=dist;
    if dist>disf
        k=j;
        disf=dist;
    end
end
vec1=zeros(L,3);
vec1(:,1)=cos(az1i).*cos(pi/2-dp1);
vec1(:,2)=sin(az1i).*cos(pi/2-dp1);
vec1(:,3)=sin(pi/2-dp1);
nvec1=sqrt(vec1(:,1).^2+vec1(:,2).^2+vec1(:,3).^2);
for i=1:3
    vec1(:,i)=vec1(:,i)./nvec1;
end
tr1=zeros(L-1,1);
for j=1:(L-1)
    disi=(vec1(end,1)*vec1(j,1)+vec1(end,2)*vec1(j,2)+vec1(end,3)*vec1(j,3));
    dist=acos(disi);
    tr1(j)=dist;
end
%
d2=(1-rf)^2.*tr1.^2+rf^2.*tr3.^2+(pi/4)^2.*(r-rf).^2;
d=sqrt(d2);
%
[f ix]=sort(d);
l9=round(length(ix)*90/100);
idx=ix(1:l9);
azf1=az1i(idx);
dpf1=dp1(idx);
azf2=az2i(idx);
dpf2=dp2(idx);
azf3=az3i(idx);
dpf3=dp3(idx);
rfin=r(idx);
disfin=tr3(idx);
%
x1 = dpf1.*sin(azf1)*2/pi;
y1 = dpf1.*cos(azf1)*2/pi;
x2 = dpf2.*sin(azf2)*2/pi;
y2 = dpf2.*cos(azf2)*2/pi;
x3 = dpf3.*sin(azf3)*2/pi;
y3 = dpf3.*cos(azf3)*2/pi;
%
X1 = dp1(end).*sin(az1(end))*2/pi;
Y1 = dp1(end).*cos(az1(end))*2/pi;
X2 = dp2(end).*sin(az2(end))*2/pi;
Y2 = dp2(end).*cos(az2(end))*2/pi;
X3 = dp3(end).*sin(az3(end))*2/pi;
Y3 = dp3(end).*cos(az3(end))*2/pi;
%
orx = 0;
ory = 0;
%
xl1 = [sin(210*pi/180) orx sin(30*pi/180)];
yl1 = [cos(210*pi/180) ory cos(30*pi/180)];
xl2 = [sin(240*pi/180) orx sin(60*pi/180)];
yl2 = [cos(240*pi/180) ory cos(60*pi/180)];
xl3 = [sin(300*pi/180) orx sin(120*pi/180)];
yl3 = [cos(300*pi/180) ory cos(120*pi/180)];
xl4 = [sin(330*pi/180) orx sin(150*pi/180)];
yl4 = [cos(330*pi/180) ory cos(150*pi/180)];
xl5 = [sin(180*pi/180) orx sin(0*pi/180)];
yl5 = [cos(180*pi/180) ory cos(0*pi/180)];
xl6 = [sin(270*pi/180) orx sin(90*pi/180)];
yl6 = [cos(270*pi/180) ory cos(90*pi/180)];
%
figure (1)
circle([0 0],1,1000,'-k');
axis square
hold on
circle([0 0],0.333,1000,'-.k');
circle([0 0],0.667,1000,'-.k');
plot(orx,ory,'*k')
plot(x1,y1,'og','MarkerFaceColor','g')
plot(x2,y2,'sb','MarkerFaceColor','b')
plot(x3,y3,'*r','MarkerFaceColor','r')
plot(xl1,yl1,'-.k',xl2,yl2,'-.k',xl3,yl3,'-.k',xl4,yl4,'-.k',xl5,yl5,'-.k',xl6,yl6,'-.k')
plot(X1,Y1,'sk',X2,Y2,'^k',X3,Y3,'ok','MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',6)
text(X1,Y1+0.1,'\sigma_1','FontSize',18)
text(X2,Y2-0.1,'\sigma_2','FontSize',18)
text(X3,Y3-0.1,'\sigma_3','FontSize',18)
hold off
axis off
xlim([-1 1])
